#include <bits/stdc++.h>
using namespace std;
long long n, k,mini;
string a,srt;
long long niz[30];
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> k;
    cin >> a;
    srt=a;
    sort(srt.begin(),srt.end());
    if (srt==a){
        for (int i=0;i<n;i++){
            if (srt[i]=='a'){
                cout << 1 << " ";
            }
            else{
                cout << 2 << " ";
            }
        }
        cout << endl;
        return 0;
    }
    a=' '+a;  // da bi bili indeksirani od keca
    for (int i=1;i<=n;i++){
        niz[a[i]-'a'+1]++; // a=1;b=2,...
        mini=1e18;
        for (int j=1;j<=k;j++){
            mini=min(mini, niz[j]);
        }

    cout << mini+1<< " ";
    }
    cout << '\n';

    return 0;
}